
#include "7040s.h"
#include "define.h"
#include "io.h"
#include "sci.h"

volatile long TimerCount;		// JE^l

void initio(void)
{
	// |[gl
	PA.DR.LONG=(unsigned long int)0xDFFFE4;
	PB.DR.WORD=(unsigned short)0x02C1;
	PC.DR.WORD=(unsigned short)0xFFFF;
	PD.DR.LONG=(unsigned short)0xBFE18000;
	PE.DR.WORD=(unsigned short)0xFFFF;
	// |[gI/OWX^
	PFC.PAIORH.WORD		= 0x0000;	// PA *0:IN, 1:OUT
//	0000 0000 0000 0000	PAIORH	l
//	          llll llll
	PFC.PAIORL.WORD		= 0x0000;	// PA *0:IN, 1:OUT
//	0000 0000 0000 0000	PAIORL	l
//	llll llll llll llll
	PFC.PBIOR.WORD		= 0x0000;	// PB *0:IN, 1:OUT
//	0000 0000 0000 0000	PBIOR	l
//	       ll llll llll
	PFC.PCIOR.WORD		= 0x0000;	// PC *0:IN, 1:OUT
//	0000 0000 0000 0000	PCIOR	l
//	llll llll llll llll
	PFC.PDIORH.WORD		= 0x0000;	// PD *0:IN, 1:OUT
//	0000 0000 0000 0000	PDIORH	l
//	llll llll llll llll
	PFC.PDIORL.WORD		= 0x0000;	// PD *0:IN, 1:OUT
//	0000 0000 0000 0000	PDIORL	l
//	llll llll llll llll
	PFC.PEIOR.WORD		= 0x0000;	// PE *0:IN, 1:OUT
//	0000 0000 0000 0000	PEIOR	l
//	llll llll llll llll
	// |[gI/OWX^ݒ

// CMT0 (1msEFCgp)
	CMT0.CMCSR.BIT.CMIE = 0;  // 荞݋֎~
	CMT0.CMCSR.BIT.CKS = 1;   // /32=CMCOR1MSkHz
	CMT0.CMCSR.BIT.CMF = 0;   // tONA
	CMT0.CMCNT = 0;           // RyA}b`JE^NA
	CMT0.CMCOR = CMCOR1MS;         // RyA}b`RX^gJE^ 1ms
// CMT1&X^[g  (1sC^[o荞݃JE^p)
	cmt1_init(1,1);	//ŏP1mS 
// VA(SCI1) 38400[bps]
	SCI1_INIT (br57600, 1, 8, 0, 1);
	SCI1_IN_DATA_CLEAR();
	SCI1_OUT_DATA_CLEAR();
// VA(SCI0) 38400[bps]
	SCI0_INIT (br57600, 1, 8, 0, 1);
	SCI0_IN_DATA_CLEAR();
	SCI0_OUT_DATA_CLEAR();
// Xe[^XWX^̊荞݃}XNݒ
	SetSRReg (0);
// LCD
#if LCD
	reset_lcd();
#endif
	//
}

/************************************************************************
*y֐z     uWait													*
*y  z     long			time	Waitliʂrj				*
************************************************************************/
/* 1usPʃEFCg              */
void uWait(long time)
{
//	long	i,j;
//	j=time;
//	j<<=1;
//	for(i=0L;i<j;i++) ;		//uS Wait
	while(time--){
		nop();		nop();		nop();		nop();
		nop();		nop();		nop();		nop();
		nop();		nop();		nop();		nop();
		nop();		nop();		nop();		nop();
		nop();		nop();		nop();		nop();
		nop();
	}
}

/************************************************************************
*y֐z     wait													*
*y  z     long			num		Waitlirj				*
************************************************************************/
/* RyA}b`^C}(CMT0)ɂ1msPʃEFCg              */
void wait(long num)
{
	long i;

	CMT.CMSTR.BIT.STR0 = 1;   // JEgJn
	for (i = 0L; i < num; i++) {
		while (!CMT0.CMCSR.BIT.CMF) ;
		CMT0.CMCSR.BIT.CMF = 0;
	}
	CMT.CMSTR.BIT.STR0 = 0;   // JEg~
}
/************************************************************************
*y֐z     cmt1_init		CMT1ij				*
*y  z     int				start	0:STOP	1:START					*
*				int				Cycle	1=1mS	10=10mS	max=50,min=1	*
*y^[lz					Ȃ									*
************************************************************************/
void cmt1_init(int start,int Cycle)
{
	CMT.CMSTR.BIT.STR1 = 0;		// CMT1JEg~
	TimerCount=0;
	CMT1.CMCSR.BIT.CMIE = 1;  // 荞݋
	CMT1.CMCSR.BIT.CKS = 1;   // /32=CMCOR1MSkHz
	CMT1.CMCSR.BIT.CMF = 0;   // tONA
	CMT1.CMCNT = 0;           // RyA}b`JE^NA
	CMT1.CMCOR = CMCOR1MS*Cycle;   // RyA}b`RX^gJE^
	INTC.IPRG.BIT._CMT1 = 1;  // CMT1RyA}b`荞ݗD惌x CMT1=1
	CMT.CMSTR.BIT.STR1 = start;		// CMT1JEgJn
}
/*--------------------------------------------------------------*/
/* RyA}b`^C}(CMT1)荞݂ɂ1or10msJE^         */
/*--------------------------------------------------------------*/
#pragma interrupt
void INT_CMT1_CMI1(void)	// int_cmi1 (void)	// 荞ݏ֐
{
//	if(CMT1.CMCSR.BIT.CMF == 1) CMT1.CMCSR.BIT.CMF = 0;		// tONA
	CMT1.CMCSR.BIT.CMF &= 0;		// tONA
	TimerCount++;	// JE^CNg
}
/************************************************************************
*y֐z     dump													*
*y@@\z     e_v									*
*y  z     unsigned int	adr		_vAhX				*
*y߂lz		Ȃ													*
************************************************************************/
void dump(unsigned int adr)
{
	unsigned char *ad,data[16];
	int	i,j;

	SCI1_PRINTF(CRLF);
	for(j=0,ad=(unsigned char*)adr;j<16;j++){
		for(i=0;i<16;i++,ad++){
			data[i]=*ad;
		}
		SCI1_PRINTF("%08X",ad-16);
		for(i=0;i<16;i++){
			SCI1_PRINTF(" %02X",data[i]);
		}
		SCI1_OUT_DATA (' ');
		for(i=0;i<16;i++){
			if(data[i]>=0x20 && data[i]<0x80)
				SCI1_OUT_DATA (data[i]);
			else
				SCI1_OUT_DATA ('.');
		}
		SCI1_PRINTF(CRLF);
	}
}

