/****************************************************************
KPIT Cummins Infosystems Ltd, Pune, India. - 05-Sept-2005.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*****************************************************************/

#include "inthandler.h"

extern void start (void);     /* Startup code (in start.s)  */
extern void stack (void);     /* stack from linker script   */

/**----------------------------------
**  Typedef for the function pointer
**-----------------------------------*/

typedef void (*fp) (void);
#define VECT_SECT          __attribute__ ((section (".vects")))

const fp HardwareVectors[] VECT_SECT = {
start,			/* 0  Power-on reset, Program counter (PC) */
(fp) stack,		/* 1  Power-on reset, Stack pointer (SP)   */
INT_Manual_Reset_PC,
(fp) stack,		//INT_Manual_Reset_SP,
INT_Illegal_code,
INT_Dummy,		/*Reserved 5*/
INT_Illegal_slot,
INT_Dummy,		/*Reserved 7*/
INT_Dummy,		/*Reserved 8*/
INT_CPU_Address,
INT_DMAC_Address,
INT_NMI,
INT_User_Break,
INT_Dummy,		/*Reserved 13*/
INT_Dummy,		/*Reserved 14*/
INT_Dummy,		/*Reserved 15*/
INT_Dummy,		/*Reserved 16*/
INT_Dummy,		/*Reserved 17*/
INT_Dummy,		/*Reserved 18*/
INT_Dummy,		/*Reserved 19*/
INT_Dummy,		/*Reserved 20*/
INT_Dummy,		/*Reserved 21*/
INT_Dummy,		/*Reserved 22*/
INT_Dummy,		/*Reserved 23*/
INT_Dummy,		/*Reserved 24*/
INT_Dummy,		/*Reserved 25*/
INT_Dummy,		/*Reserved 26*/
INT_Dummy,		/*Reserved 27*/
INT_Dummy,		/*Reserved 28*/
INT_Dummy,		/*Reserved 29*/
INT_Dummy,		/*Reserved 30*/
INT_Dummy,		/*Reserved 31*/
INT_TRAPA32,
INT_TRAPA33,
INT_TRAPA34,
INT_TRAPA35,
INT_TRAPA36,
INT_TRAPA37,
INT_TRAPA38,
INT_TRAPA39,
INT_TRAPA40,
INT_TRAPA41,
INT_TRAPA42,
INT_TRAPA43,
INT_TRAPA44,
INT_TRAPA45,
INT_TRAPA46,
INT_TRAPA47,
INT_TRAPA48,
INT_TRAPA49,
INT_TRAPA50,
INT_TRAPA51,
INT_TRAPA52,
INT_TRAPA53,
INT_TRAPA54,
INT_TRAPA55,
INT_TRAPA56,
INT_TRAPA57,
INT_TRAPA58,
INT_TRAPA59,
INT_TRAPA60,
INT_TRAPA61,
INT_TRAPA62,
INT_TRAPA63,
INT_IRQ0,
INT_IRQ1,
INT_IRQ2,
INT_IRQ3,
INT_IRQ4,
INT_IRQ5,
INT_IRQ6,
INT_IRQ7,
INT_DMAC0_DEI0,
INT_Dummy,		/*Reserved 73*/
INT_Dummy,		/*Reserved 74*/
INT_Dummy,		/*Reserved 75*/
INT_DMAC1_DEI1,
INT_Dummy,		/*Reserved 77*/
INT_Dummy,		/*Reserved 78*/
INT_Dummy,		/*Reserved 79*/
INT_DMAC3_DEI2,
INT_Dummy,		/*Reserved 81*/
INT_Dummy,		/*Reserved 82*/
INT_Dummy,		/*Reserved 83*/
INT_DMAC3_DEI3,
INT_Dummy,		/*Reserved 85*/
INT_Dummy,		/*Reserved 86*/
INT_Dummy,		/*Reserved 87*/
INT_MTU0_TGI0A,
INT_MTU0_TGI0B,
INT_MTU0_TGI0C,
INT_MTU0_TGI0D,
INT_MTU0_TCI0V,
INT_Dummy,		/*Reserved 93*/
INT_Dummy,		/*Reserved 94*/
INT_Dummy,		/*Reserved 95*/
INT_MTU1_TGI1A,
INT_MTU1_TGI1B,
INT_Dummy,		/*Reserved 98*/
INT_Dummy,		/*Reserved 99*/
INT_MTU1_TCI1V,
INT_MTU1_TCI1U,
INT_Dummy,		/*Reserved 102*/
INT_Dummy,		/*Reserved 103*/
INT_MTU2_TGI2A,
INT_MTU2_TGI2B,
INT_Dummy,		/*Reserved 106*/
INT_Dummy,		/*Reserved 107*/
INT_MTU2_TCI2V,
INT_MTU2_TCI2U,
INT_Dummy,		/*Reserved 110*/
INT_Dummy,		/*Reserved 111*/
INT_MTU3_TGI3A,
INT_MTU3_TGI3B,
INT_MTU3_TGI3C,
INT_MTU3_TGI3D,
INT_MTU3_TCI3V,
INT_Dummy,		/*Reserved 117*/
INT_Dummy,		/*Reserved 118*/
INT_Dummy,		/*Reserved 119*/
INT_MTU4_TGI4A,
INT_MTU4_TGI4B,
INT_MTU4_TGI4C,
INT_MTU4_TGI4D,
INT_MTU4_TCI4V,
INT_Dummy,		/*Reserved 125*/
INT_Dummy,		/*Reserved 126*/
INT_Dummy,		/*Reserved 127*/
INT_SCI0_ERI0,
INT_SCI0_RXI0,
INT_SCI0_TXI0,
INT_SCI0_TEI0,
INT_SCI1_ERI1,
INT_SCI1_RXI1,
INT_SCI1_TXI1,
INT_SCI1_TEI1,
INT_ADI0,
INT_ADI1,
INT_Dummy,		/*Reserved 138*/
INT_Dummy,		/*Reserved 139*/
INT_DTC_SWDTCE,
INT_Dummy,		/*Reserved 141*/
INT_Dummy,		/*Reserved 142*/
INT_Dummy,		/*Reserved 143*/
INT_CMT0_CMI0,
INT_Dummy,		/*Reserved 145*/
INT_Dummy,		/*Reserved 146*/
INT_Dummy,		/*Reserved 147*/
INT_CMT1_CMI1,
INT_Dummy,		/*Reserved 149*/
INT_Dummy,		/*Reserved 150*/
INT_Dummy,		/*Reserved 151*/
INT_INT_WDT_ITI,
INT_BSC_CMI,
INT_Dummy,		/*Reserved 154*/
INT_Dummy,		/*Reserved 155*/
INT_INT_OEI,
INT_Dummy,		/*Reserved 157*/
INT_Dummy,		/*Reserved 158*/
INT_Dummy,		/*Reserved 159*/
INT_Dummy,		/*Reserved 160*/
INT_Dummy,		/*Reserved 161*/
INT_Dummy,		/*Reserved 162*/
INT_Dummy,		/*Reserved 163*/
INT_Dummy,		/*Reserved 164*/
INT_Dummy,		/*Reserved 165*/
INT_Dummy,		/*Reserved 166*/
INT_Dummy,		/*Reserved 167*/
INT_Dummy,		/*Reserved 168*/
INT_Dummy,		/*Reserved 169*/
INT_Dummy,		/*Reserved 170*/
INT_Dummy,		/*Reserved 171*/
INT_Dummy,		/*Reserved 172*/
INT_Dummy,		/*Reserved 173*/
INT_Dummy,		/*Reserved 174*/
INT_Dummy,		/*Reserved 175*/
INT_Dummy,		/*Reserved 176*/
INT_Dummy,		/*Reserved 177*/
INT_Dummy,		/*Reserved 178*/
INT_Dummy,		/*Reserved 179*/
INT_Dummy,		/*Reserved 180*/
INT_Dummy,		/*Reserved 181*/
INT_Dummy,		/*Reserved 182*/
INT_Dummy,		/*Reserved 183*/
INT_Dummy,		/*Reserved 184*/
INT_Dummy,		/*Reserved 185*/
INT_Dummy,		/*Reserved 186*/
INT_Dummy,		/*Reserved 187*/
INT_Dummy,		/*Reserved 188*/
INT_Dummy,		/*Reserved 189*/
INT_Dummy,		/*Reserved 190*/
INT_Dummy,		/*Reserved 191*/
INT_Dummy,		/*Reserved 192*/
INT_Dummy,		/*Reserved 193*/
INT_Dummy,		/*Reserved 194*/
INT_Dummy,		/*Reserved 195*/
INT_Dummy,		/*Reserved 196*/
INT_Dummy,		/*Reserved 197*/
INT_Dummy,		/*Reserved 198*/
INT_Dummy,		/*Reserved 199*/
INT_Dummy,		/*Reserved 200*/
INT_Dummy,		/*Reserved 201*/
INT_Dummy,		/*Reserved 202*/
INT_Dummy,		/*Reserved 203*/
INT_Dummy,		/*Reserved 204*/
INT_Dummy,		/*Reserved 205*/
INT_Dummy,		/*Reserved 206*/
INT_Dummy,		/*Reserved 207*/
INT_Dummy,		/*Reserved 208*/
INT_Dummy,		/*Reserved 209*/
INT_Dummy,		/*Reserved 210*/
INT_Dummy,		/*Reserved 211*/
INT_Dummy,		/*Reserved 212*/
INT_Dummy,		/*Reserved 213*/
INT_Dummy,		/*Reserved 214*/
INT_Dummy,		/*Reserved 215*/
INT_Dummy,		/*Reserved 216*/
INT_Dummy,		/*Reserved 217*/
INT_Dummy,		/*Reserved 218*/
INT_Dummy,		/*Reserved 219*/
INT_Dummy,		/*Reserved 220*/
INT_Dummy,		/*Reserved 221*/
INT_Dummy,		/*Reserved 222*/
INT_Dummy,		/*Reserved 223*/
INT_Dummy,		/*Reserved 224*/
INT_Dummy,		/*Reserved 225*/
INT_Dummy,		/*Reserved 226*/
INT_Dummy,		/*Reserved 227*/
INT_Dummy,		/*Reserved 228*/
INT_Dummy,		/*Reserved 229*/
INT_Dummy,		/*Reserved 230*/
INT_Dummy,		/*Reserved 231*/
INT_Dummy,		/*Reserved 232*/
INT_Dummy,		/*Reserved 233*/
INT_Dummy,		/*Reserved 234*/
INT_Dummy,		/*Reserved 235*/
INT_Dummy,		/*Reserved 236*/
INT_Dummy,		/*Reserved 237*/
INT_Dummy,		/*Reserved 238*/
INT_Dummy,		/*Reserved 239*/
INT_Dummy,		/*Reserved 240*/
INT_Dummy,		/*Reserved 241*/
INT_Dummy,		/*Reserved 242*/
INT_Dummy,		/*Reserved 243*/
INT_Dummy,		/*Reserved 244*/
INT_Dummy,		/*Reserved 245*/
INT_Dummy,		/*Reserved 246*/
INT_Dummy,		/*Reserved 247*/
INT_Dummy,		/*Reserved 248*/
INT_Dummy,		/*Reserved 249*/
INT_Dummy,		/*Reserved 250*/
INT_Dummy,		/*Reserved 251*/
INT_Dummy,		/*Reserved 252*/
INT_Dummy,		/*Reserved 253*/
INT_Dummy,		/*Reserved 254*/
INT_Dummy,		/*Reserved 255*/
};
